'use client'
import React, { useEffect, useState } from 'react';
import { APIProvider, Map, Marker, useMap } from '@vis.gl/react-google-maps';

// @ts-ignore
const GoogleMap = (props) => {
    const API_KEY = 'AIzaSyAsh-ofw4XiKuvo4W1GOIutG7NpHLbp2Hw'

    const getUserLocation = () => {
        if (!navigator.geolocation) {
            alert('Geolocation is not supported by your browser.');
            return;
        }

        navigator.geolocation.getCurrentPosition(
            (position) => {
                const { latitude, longitude } = position.coords;
                // setUserLocation({ lat: latitude, lng: longitude });
            },
            () => {
                console.log('not get user location')
                getUserLocation()
            }
        );
    }
    // Get user's live location
    useEffect(() => {
        getUserLocation()
    }, []);

    return (
        <>
            <APIProvider apiKey={API_KEY} libraries={['marker']}>
                <Map
                    mapId={'7a9e2ebecd32a903'}
                    style={{ width: '100%', height: '650px' }}
                    defaultCenter={{ lat: 37.7749, lng: -122.4194 }}
                    defaultZoom={18}
                    gestureHandling={'greedy'}
                    fullscreenControl={false}
                    {...props}
                >
                    {props?.children}
                </Map>
            </APIProvider>
        </>
    );
};


// @ts-ignore
export function PolylineMap({ path, strokeColor = 'rgba(15,83,255,0.7)' }) {
    const map = useMap();

    useEffect(() => {
        if (!map) return;

        // Create a Polyline object
        const polyline = new google.maps.Polyline({
            path: path,
            geodesic: true,
            strokeColor: strokeColor, // Color of the polyline
            strokeOpacity: 1.0,
            strokeWeight: 5,
            map: map,
        });

        // Clean up the polyline on component unmount
        return () => polyline.setMap(null);
    }, [map, path]);

    return <></>;
}


export default GoogleMap;


export const getMarkerIcon = (color: any) => ({
    path: 'M12 2C8.13 2 5 5.13 5 9c0 3.87 7 11 7 11s7-7.13 7-11c0-3.87-3.13-7-7-7z',
    fillColor: color,
    fillOpacity: 1,
    strokeColor: 'black',
    strokeWeight: 1,
    scale: 2.1,
    // Set the anchor point for the marker
    anchor: new google.maps.Point(12, 24),
    // Set the origin point of the marker (top-left corner)
    origin: new google.maps.Point(0, 0),
    // Set the position of the label relative to the marker
    labelOrigin: new google.maps.Point(12, 10),
    // Rotation of the marker in degrees (0-360)
    rotation: 0,
    // Determines whether the icon is aligned with the map (heading) or the marker itself (default)
    iconHeading: 0,
});

export const MovingMarker = () => {
    const [position, setPosition] = useState<google.maps.LatLngLiteral>({
        lat: 0,
        lng: 0
    });

    const [path, setPath] = useState<google.maps.LatLngLiteral[]>([]);

    const [officers, setOfficers] = useState<any[]>([
        { lat: 24.955952406193777, lng: 67.05510008595161 },
        { lat: 24.955787045206144, lng: 67.05532539149685 },
        { lat: 24.955738409579283, lng: 67.05538976450977 },
        { lat: 24.955534139736653, lng: 67.05565798539695 },
        { lat: 24.95458087598997, lng: 67.05693471681995 },
        { lat: 24.95429878632324, lng: 67.0574175144169 },

        { lat: 24.95432246725668, lng: 67.05748317239625 },
        { lat: 24.954372485238892, lng: 67.0575553154991 },
        { lat: 24.954418655665993, lng: 67.05760624004232 },
        { lat: 24.95442635073551, lng: 67.05765716458552 },
        { lat: 24.954434045804515, lng: 67.05772506397646 },
        { lat: 24.954376332775155, lng: 67.05786510647027 },
        { lat: 24.954199345983092, lng: 67.0580178800999 },

        { lat: 24.954126242668643, lng: 67.05799666154023 },
        { lat: 24.95392232266739, lng: 67.05791178730156 },
        { lat: 24.953622213372036, lng: 67.05748317239625 },
        { lat: 24.953137419888265, lng: 67.05710123832219 },
    ]);

    useEffect(() => {
        let i = 0;
        const interval = setInterval(() => {
            const newPosition = {
                lat: officers[i].lat,
                lng: officers[i].lng
            };
            setPosition(newPosition);
            if ((i) % officers.length == 0) {
                setPath([])
                setPath((prevPath) => [...prevPath, newPosition]);
            } else {
                setPath((prevPath) => [...prevPath, newPosition]);
            }

            console.log('s', (i) % officers.length)
            i = (i + 1) % officers.length;
        }, 1500);

        return () => clearInterval(interval);


    }, [officers]);

    return (
        <>
            <PolylineMap path={path} strokeColor={'#b9b8b8'} />
            <Marker position={position} title="Officer 1" />
        </>
    );
};